// SumBin.cpp: implementation of the CSumBin class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Summing1.h"
#include "SumBin.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

IMPLEMENT_DYNAMIC(CSumBin, CWnd)

CSumBin::CSumBin()
{
	RegisterWindowClass();
	picarry = NULL;
	m_i1=m_i2=m_ic=m_ir=m_irc=0;	
}

CSumBin::~CSumBin()
{
	
}

BEGIN_MESSAGE_MAP(CSumBin, CWnd)
	//{{AFX_MSG_MAP(CSumBin)		
	ON_WM_PAINT()
	ON_WM_CREATE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

BOOL CSumBin::RegisterWindowClass()
{
	WNDCLASS wndcls;
	HINSTANCE hInst = AfxGetInstanceHandle();

	if( !(::GetClassInfo(hInst, NETWORK_CLASSNAME, &wndcls)) )
	{
		wndcls.style = CS_DBLCLKS | CS_HREDRAW | CS_VREDRAW;
		wndcls.lpfnWndProc		= ::DefWindowProc;
		wndcls.cbClsExtra       = wndcls.cbWndExtra = 0;
        wndcls.hInstance        = hInst;
        wndcls.hIcon            = NULL;
        wndcls.hCursor          = AfxGetApp()->LoadStandardCursor(IDC_ARROW);
        wndcls.hbrBackground    = (HBRUSH)(COLOR_BTNFACE);
        wndcls.lpszMenuName     = NULL;
        wndcls.lpszClassName    = NETWORK_CLASSNAME;

        if (!AfxRegisterClass(&wndcls))
        {
            AfxThrowResourceException();
            return FALSE;
        }
	}

	return TRUE;
}

void CSumBin::Input(int i1, int i2, int ic)
{
	m_i1 = i1, m_i2 = i2, m_ic = ic;
	hiddenneuron1();hiddenneuron2();hiddenneuron3();hiddenneuron4();
	carry();
}

#define ARE_THERE_SRC_IN_DST(src,dst,size,bfnd) \
	bool dbfounded = false; \
	for(int di=0; di<size; di++) \
	{ \
		if(strcmp(src,&dst[di][0])==0) \
		{ \
			dbfounded = true; \
			break; \
		} \
	} \
	bfnd = dbfounded \

void CSumBin::hiddenneuron1()
{
	char *cmp[] = {
		"000"
	};
	char ssr[4]; memset(ssr,0,4*sizeof(char));	
	itoa(m_i1,(ssr+0),2);
	itoa(m_i2,(ssr+1),2);
	itoa(m_ic,(ssr+2),2);
	bool bfounded = false;
	ARE_THERE_SRC_IN_DST(ssr,cmp,1,bfounded);
	(bfounded)?m_ir = 0:NULL;
}

void CSumBin::hiddenneuron2()
{
	char *cmp[] =
	{
		"100",
	    "010",
		"001"
	};
	char ssr[4]; memset(ssr,0,4*sizeof(char));
	itoa(m_i1,(ssr+0),2);
	itoa(m_i2,(ssr+1),2);
	itoa(m_ic,(ssr+2),2);
	bool bfounded = false;
	ARE_THERE_SRC_IN_DST(ssr,cmp,3,bfounded);
	(bfounded)?m_ir = 1:NULL;
}

void CSumBin::hiddenneuron3()
{
	char *cmp[] = 
	{
		"011",
		"110",
		"101"
	};
	char ssr[4]; memset(ssr,0,4*sizeof(char));
	itoa(m_i1,(ssr+0),2);
	itoa(m_i2,(ssr+1),2);
	itoa(m_ic,(ssr+2),2);
	bool bfounded = false;
	ARE_THERE_SRC_IN_DST(ssr,cmp,3,bfounded);
	(bfounded)?m_ir = 0:NULL;
}

void CSumBin::hiddenneuron4()
{
	char *cmp[] = {
		"111"
	};
	char ssr[4]; memset(ssr,0,4*sizeof(char));
	itoa(m_i1,(ssr+0),2);
	itoa(m_i2,(ssr+1),2);
	itoa(m_ic,(ssr+2),2);
	bool bfounded = false;
	ARE_THERE_SRC_IN_DST(ssr,cmp,1,bfounded);
	(bfounded)?m_ir = 1:NULL;
}

int CSumBin::xor()
{
	return m_ir;
}

int CSumBin::carry()
{
	int icnt=0;
	if(m_i1 == 1) ++icnt;
	if(m_i2 == 1) ++icnt;
	if(m_ic == 1) ++icnt;
	if( icnt>=2) m_irc = 1;
	return m_irc;
}

void CSumBin::OnPaint() 
{
	CPaintDC dc(this); // device context for painting
	
	// TODO: Add your message handler code here
	DrawNetwork(&dc);
	// Do not call CWnd::OnPaint() for painting messages
}

void CSumBin::DrawNetwork(	CPaintDC *pdc)
{
	CBrush br,*poldbr;
	br.CreateSolidBrush(RGB(0,150,0));
	poldbr = (CBrush*)pdc->SelectObject(&br);
	CRect clrt;
	GetClientRect(clrt);	
	pdc->Rectangle(clrt);		

	int iclW = clrt.Width(), iclH = clrt.Height();
	int icol = iclW/8, irow = iclH/7;

	//input
	char csbit[2];
	memset(csbit,0,2);
	CRect InRtAr[3];
	br.DeleteObject();
	br.CreateSolidBrush(RGB(255,255,255));	
	pdc->SelectObject(&br);
	InRtAr[0] = CRect(1*icol,1*irow,1*icol+icol,1*irow+irow);
	pdc->Ellipse(InRtAr[0]);	
	itoa(m_i1,csbit,2);
	pdc->TextOut(InRtAr[0].CenterPoint().x - 5,InRtAr[0].CenterPoint().y - 7,csbit);
	br.DeleteObject();
	br.CreateSolidBrush(RGB(255,0,0));
	pdc->SelectObject(&br);
	InRtAr[1] = CRect(1*icol,3*irow,1*icol+icol,3*irow+irow);
	pdc->Ellipse(InRtAr[1]);
	itoa(m_ic,csbit,2);
	pdc->TextOut(InRtAr[1].CenterPoint().x - 5,InRtAr[1].CenterPoint().y - 7,csbit);
	br.DeleteObject();
	br.CreateSolidBrush(RGB(255,255,255));	
	pdc->SelectObject(&br);
	InRtAr[2] = CRect(1*icol,5*irow,1*icol+icol,5*irow+irow);	
	pdc->Ellipse(InRtAr[2]);
	itoa(m_i2,csbit,2);
	pdc->TextOut(InRtAr[2].CenterPoint().x - 5,InRtAr[2].CenterPoint().y - 7,csbit);

	//hidden neuron
	CRect HNRtAr[4];
	br.DeleteObject();
	br.CreateSolidBrush(RGB(0,0,255));	
	pdc->SelectObject(&br);
	HNRtAr[0] = CRect(3*icol,0*irow,3*icol+icol,0*irow+irow);
	pdc->Ellipse(HNRtAr[0]);	
	pdc->TextOut(HNRtAr[0].CenterPoint().x + 15,HNRtAr[0].CenterPoint().y - 7,"H1");
	HNRtAr[1] = CRect(3*icol,2*irow,3*icol+icol,2*irow+irow);
	pdc->Ellipse(HNRtAr[1]);
	pdc->TextOut(HNRtAr[1].CenterPoint().x + 15,HNRtAr[1].CenterPoint().y - 7,"H2");
	HNRtAr[2] = CRect(3*icol,4*irow,3*icol+icol,4*irow+irow);
	pdc->Ellipse(HNRtAr[2]);
	pdc->TextOut(HNRtAr[2].CenterPoint().x + 15,HNRtAr[2].CenterPoint().y - 7,"H3");
	HNRtAr[3] = CRect(3*icol,6*irow,3*icol+icol,6*irow+irow);
	pdc->Ellipse(HNRtAr[3]);
	pdc->TextOut(HNRtAr[3].CenterPoint().x + 15,HNRtAr[3].CenterPoint().y - 7,"H4");

	//or
	CRect OrRt;
	br.DeleteObject();
	br.CreateSolidBrush(RGB(0,0,0));	
	pdc->SelectObject(&br);
	OrRt = CRect(5*icol,3*irow,5*icol+icol,3*irow+irow);
	pdc->Ellipse(OrRt);
	itoa(m_ir,csbit,2);
	pdc->TextOut(OrRt.CenterPoint().x,OrRt.CenterPoint().y - 7,csbit);

	//carry
	CRect CrRt;
	br.DeleteObject();
	br.CreateSolidBrush(RGB(255,0,0));	
	pdc->SelectObject(&br);
	CrRt = CRect(7*icol,3*irow,7*icol+icol,3*irow+irow);
	pdc->Ellipse(CrRt);
	itoa(m_irc,csbit,2);
	pdc->TextOut(CrRt.CenterPoint().x,CrRt.CenterPoint().y - 7,csbit);

	br.DeleteObject();
	
	//Draw line from input to hidden neuron
	for(int i=0; i<3; i++)
	{
		CPen pen;
		switch(i)
		{
		case 0:			
			pen.CreatePen(PS_SOLID,1,RGB(255,0,0));
			pdc->SelectObject(&pen);			
			break;
		case 1:			
			pen.CreatePen(PS_SOLID,1,RGB(0,255,0));
			pdc->SelectObject(&pen);			
			break;
		case 2:		
			pen.CreatePen(PS_SOLID,1,RGB(0,0,255));
			pdc->SelectObject(&pen);			
			break;
		}
		pdc->MoveTo(InRtAr[i].CenterPoint());
		pdc->LineTo(HNRtAr[0].CenterPoint());
		pdc->MoveTo(InRtAr[i].CenterPoint());
		pdc->LineTo(HNRtAr[1].CenterPoint());
		pdc->MoveTo(InRtAr[i].CenterPoint());
		pdc->LineTo(HNRtAr[2].CenterPoint());
		pdc->MoveTo(InRtAr[i].CenterPoint());
		pdc->LineTo(HNRtAr[3].CenterPoint());

		pen.DeleteObject();
	}

	//DrawLine from hidden neuron to or
	for(i=0; i<4; i++)
	{
		CPen pen;
		pen.CreatePen(PS_SOLID,1,RGB(255,255,0));
		pdc->SelectObject(&pen);			
		pdc->MoveTo(HNRtAr[i].CenterPoint());
		pdc->LineTo(OrRt.CenterPoint());
		pen.DeleteObject();
	}

	//DrawLine from input to carry
	for(i=0; i<3; i++)
	{
		CPen pen;
		pen.CreatePen(PS_SOLID,1,RGB(255,0,255));
		pdc->SelectObject(&pen);			
		pdc->MoveTo(InRtAr[i].CenterPoint());
		CRect rt = InRtAr[i];
		if(i!=1)
		{					
			rt.left += 100;
			rt.right += 100;
			pdc->LineTo(rt.CenterPoint());
			pdc->LineTo(CrRt.CenterPoint());
		}
		else
		{
			rt.left += 85;
			rt.right += 85;
			pdc->LineTo(rt.CenterPoint());
			rt.left += 30;
			rt.right += 30;
			pdc->MoveTo(rt.CenterPoint());
			pdc->LineTo(CrRt.CenterPoint());

		}
		pen.DeleteObject();
	}
}

int CSumBin::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	// TODO: Add your specialized creation code here
	//CRect wrt;
	//GetClientRect(wrt);
	//TRACE("left=%d top=%d right=%d bot=%d\n",wrt.left,wrt.top,wrt.right,wrt.bottom);	
	//CRgn rgn;
	//rgn.CreateRoundRectRgn(0,0,100,100,100,100);	
	//this->SetWindowRgn(rgn,true);
	return 0;
}
