// Summing1View.cpp : implementation of the CSumming1View class
//

#include "stdafx.h"
#include "Summing1.h"

#include "Summing1Doc.h"
#include "Summing1View.h"
#include "SumBin.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSumming1View

#define DEF_NET_WIDTH		200
#define DEF_NET_HEIGHT		150

IMPLEMENT_DYNCREATE(CSumming1View, CView)

BEGIN_MESSAGE_MAP(CSumming1View, CView)
	//{{AFX_MSG_MAP(CSumming1View)
	ON_WM_CREATE()
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CView::OnFilePrintPreview)
	ON_BN_CLICKED(IDC_BTN_APPLY,OnBtnApply)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSumming1View construction/destruction

CSumming1View::CSumming1View()
{
	// TODO: add construction code here	
}

CSumming1View::~CSumming1View()
{
}

BOOL CSumming1View::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CSumming1View drawing

void CSumming1View::OnDraw(CDC* pDC)
{
	CSumming1Doc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	// TODO: add draw code for native data here	
	CString cstr;
	cstr = "H1: 0,0,0 -> 0        Carry: if '1' exists more than one in inputs carry = 1 otherwise carry = 0\n\
H2: 1,0,0 | 0,1,0 | 0,0,1 -> 1\n\
H3: 1,1,0 | 1,0,1 | 0,1,1 -> 0\n\
H4: 1,1,1 -> 1\n";	
	pDC->DrawText(cstr,CRect(220,10,220+700,10+200),DT_LEFT|DT_TOP);	
}

/////////////////////////////////////////////////////////////////////////////
// CSumming1View printing

BOOL CSumming1View::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CSumming1View::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}

void CSumming1View::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}

/////////////////////////////////////////////////////////////////////////////
// CSumming1View diagnostics

#ifdef _DEBUG
void CSumming1View::AssertValid() const
{
	CView::AssertValid();
}

void CSumming1View::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CSumming1Doc* CSumming1View::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CSumming1Doc)));
	return (CSumming1Doc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CSumming1View message handlers

int CSumming1View::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CView::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	// TODO: Add your specialized creation code here
	m_editinput1.Create(WS_CHILD|WS_VISIBLE|WS_BORDER,DefRectCalc(10,10),this,IDC_EDIT_INPUT1);	
	m_editinput2.Create(WS_CHILD|WS_VISIBLE|WS_BORDER,DefRectCalc(10,40),this,IDC_EDIT_INPUT2);
	m_btnapply.Create("Calcurate",WS_CHILD|WS_VISIBLE,DefRectCalc(10,70),this,IDC_BTN_APPLY);
	return 0;
}

void CSumming1View::OnBtnApply()
{
	CString strinput1,strinput2;
	GetDlgItem(IDC_EDIT_INPUT1)->GetWindowText(strinput1);
	GetDlgItem(IDC_EDIT_INPUT2)->GetWindowText(strinput2);

	////////////fit lenth of strinput1 & strinput2 in same//////////////
	int ilen;
	if(strinput1.GetLength()>strinput2.GetLength())
	{
		ilen = strinput1.GetLength() - strinput2.GetLength();
		CString str = "";
		for(int i=0; i<ilen; i++)
		{
			str += "0";
		}
		strinput2 = str + strinput2;
	}
	else
	{
		ilen = strinput2.GetLength() - strinput1.GetLength();
		CString str = "";
		for(int i=0; i<ilen; i++)
		{
			str += "0";
		}
		strinput1 = str + strinput1;
	}
	TRACE("strinput1 = %s strinput2 = %s\n",strinput1,strinput2);
	////////////fit lenth of strinput1 & strinput2 in same//////////////

	CString strbit1,strbit2;	
	ilen = strinput1.GetLength();
	CRect clRect,netRect;
	GetWindowRect(clRect);
	int iclW = clRect.Width(), iclH = clRect.Height();
	int icol = iclW/DEF_NET_WIDTH, irow = iclH/DEF_NET_HEIGHT;
	int inetnum = 0;
	
	if(dlist_size(&m_dlist)==-1)dlist_init(&m_dlist,NULL);
	else
	{
		DestroyNetwork();
		dlist_init(&m_dlist,NULL);
	}
	for(int i=1; i<=ilen; i++)
	{
		strbit1 = strinput1.GetAt(strinput1.GetLength()-i);
		strbit2 = strinput2.GetAt(strinput2.GetLength()-i);					
		if(dlist_size(&m_dlist)==0)
		{
			CSumBin *pSumBin = new CSumBin;
			pSumBin->Input(atoi(strbit1),atoi(strbit2),0);
			netRect = CRect(inetnum%icol*DEF_NET_WIDTH+10,
				inetnum/irow*DEF_NET_HEIGHT+100,
				(inetnum%icol*DEF_NET_WIDTH)+DEF_NET_WIDTH+10,
				(inetnum/irow*DEF_NET_HEIGHT)+DEF_NET_HEIGHT+100);
			pSumBin->Create(NETWORK_CLASSNAME, _T(""), WS_CHILD|WS_VISIBLE,netRect, this, 0);	
			inetnum++;			
			dlist_ins_prev(&m_dlist,dlist_head(&m_dlist),pSumBin);
		}			
		else
		{
			CSumBin *pSumBin = new CSumBin;
			DListElmt* pelement;
			pelement = dlist_head(&m_dlist);
			CSumBin *pRefSumBin = (CSumBin*)dlist_data(pelement);
			pSumBin->Input(atoi(strbit1),atoi(strbit2),pRefSumBin->carry());
			netRect = CRect(inetnum%icol*DEF_NET_WIDTH+10,
				inetnum/irow*DEF_NET_HEIGHT+100,
				(inetnum%icol*DEF_NET_WIDTH)+DEF_NET_WIDTH+10,
				(inetnum/irow*DEF_NET_HEIGHT)+DEF_NET_HEIGHT+100);
			pSumBin->Create(NETWORK_CLASSNAME, _T(""), WS_CHILD|WS_VISIBLE,netRect, this, 0);
			inetnum++;			
			dlist_ins_prev(&m_dlist,pelement,pSumBin);
		}				
	}	
}

void CSumming1View::OnDestroy() 
{
	CView::OnDestroy();
	
	// TODO: Add your message handler code here
	if(dlist_size(&m_dlist)!=0&&dlist_size(&m_dlist)!=-1)
		DestroyNetwork();
}

void CSumming1View::DestroyNetwork()
{
	DListElmt *pelement;
	pelement = dlist_head(&m_dlist);
	while(1)
	{
		CSumBin* pSumBin = (CSumBin*)dlist_data(pelement);
		pSumBin->SendMessage(WM_CLOSE,0,0);
		delete pSumBin;
		if(dlist_is_tail(pelement))
			break;
		pelement = dlist_next(pelement);
	}		

	dlist_destroy(&m_dlist);
}
